CREATE TABLE kim_user(
	'name' VARCHAR(255) NOT NULL PRIMARY KEY,
	'uidNumber' INT NOT NULL,
	'gidNumber' INT,
	'gecos' VARCHAR(255),
	'homedir' TEXT,
	'bash' TEXT,
	'krbprincipalName' TEXT,
	'createTimestamp' INTEGER,
	'modifyTimestamp' INTEGER,
	'cachedTimestamp' INTEGER,
	'passwordExpiration' INTEGER,
	'dataExpiration' INTEGER,
	'isPosix' INT,
	'isLocked' INT,
	'isEnable' INT,
	'failedLoginAttempts' INT,
	'uniqueID' TEXT,
	'memberof_groups' TEXT,
	'memberofindirect_group' TEXT,
	'memberof_hbacrule' TEXT,
        'memberof_sudorule' TEXT,
        'logintimeset' CHAR(20),
        'accountExpiration' INTEGER,
        'lastFailedTime' INTEGER,
        'lastUnlockTime' INTEGER,
        'addomain' TEXT,
        'pwdFailedCount' INTEGER,
        'pwdFailedReset' INTEGER,
        'pwdLockoutSec' INTEGER,
        'semap' TEXT
);

CREATE TABLE kim_group(
	'name' VARCHAR(255) NOT NULL PRIMARY KEY,
	'gidNumber' INT,
	'users' TEXT,
	'isPosix' INT,
	'createTimestamp' INTEGER,
	'modifyTimestamp' INTEGER,
	'cachedTimestamp' INTEGER,
	'uniqueID' TEXT,
	'memberof_groups' TEXT,
	'memberof_hbacrule' TEXT,
	'memberof_sudorule' TEXT
);

CREATE TABLE kim_host(
	'name' VARCHAR(255) NOT NULL PRIMARY KEY,
	'isEnrolled' INT,
	'isEnabled' INT,
	'createTimestamp' INTEGER,
	'modifyTimestamp' INTEGER,
	'cachedTimestamp' INTEGER,
	'uniqueID' TEXT,
	'memberof_hbacrule' TEXT
);

CREATE TABLE kim_hbac(
	'name' VARCHAR(255) NOT NULL PRIMARY KEY,
	'isEnabled' INT,
	'createTimestamp' INTEGER,
	'modifyTimestamp' INTEGER,
	'cachedTimestamp' INTEGER,
	'uniqueID' TEXT,
	'allow_users' TEXT,
	'allow_groups' TEXT,
	'allow_service' TEXT
);

CREATE TABLE kim_config(
        'section' VARCHAR(64),
        'key' VARCHAR,
        'value' VARCHAR
);

CREATE TABLE kim_user_groups(
        'userName' VARCHAR(255) NOT NULL,
        'groupName' VARCHAR(255) NOT NULL,
        'validBefore' INTEGER,
        'validAfter' INTEGER
);

CREATE TABLE kim_net_storage(
        'name' VARCHAR(255) NOT NULL,
        'address' VARCHAR(128),
        'protocol' VARCHAR(64),
        'mountMode' VARCHAR(20),
        'userName' VARCHAR(255),
        'autoMount' INT
);

CREATE TABLE  IF NOT EXISTS kim_login_record(
        'user' VARCHAR(255) NOT NULL,
        'service' VARCHAR(255),
        'pid' INT,
        'logincmd' VARCHAR(255),
        'loginType' INT,
        'homeDir' TEXT,
        'loginLocalTime' INTEGER,
        'loginRemoteTime' INTEGER,
        'recordFlag' INT
);

INSERT INTO kim_group('name', 'gidNumber', 'isPosix') values('diskadm', '5001', 1);

INSERT INTO kim_group('name', 'gidNumber', 'isPosix') values('pkgadm', '5002', 1);

INSERT INTO kim_group('name', 'gidNumber', 'isPosix') values('pkginst', '5003', 1);

INSERT INTO kim_group('name', 'gidNumber', 'isPosix') values('usbcreator', '5004', 1);

INSERT INTO kim_group('name', 'gidNumber', 'isPosix') values('mountadm', '5005', 1);

INSERT INTO kim_group('name', 'gidNumber', 'isPosix') values('sysdadm', '5007', 1);

INSERT INTO kim_group('name', 'gidNumber', 'isPosix') values('pkexadm', '5008', 1);

INSERT INTO kim_group('name', 'gidNumber', 'isPosix') values('timeadm', '5010', 1);

INSERT INTO kim_group('name', 'gidNumber', 'isPosix') values('kimuadm', '5011', 1);
